%define anolis_release 4

%global LIBVER 2.1.0

Name:               gpm
Version:            1.20.7
Release:            %{anolis_release}%{?dist}
Summary:            A mouse server for the Linux console
License:            GPLv2 and OFSFDL
URL:                http://www.nico.schottelius.org/software/gpm/
Source0:            %{name}-%{version}.tar.xz
Source1:            gpm.service

Patch1:             0001-typo-1.20.5-should-have-been-1.20.6.patch
Patch2:             0002-switch-to-xz.patch
Patch3:             0003-install-shared-lib-with-x-perms.patch
Patch4:             0004-change-1.20.8.patch
Patch5:             0005-ensure-permissions-are-setup-correctly.patch
Patch6:             0006-kill-printf-3-format-warning-for-time_t.patch
Patch7:             0007-fix-highly-illegal-return-of-int-as-char-and-less-wo.patch
Patch8:             0008-of-course-we-can.-fixes-value-computed-is-unused-war.patch
Patch9:             0009-if-you-re-using-strlen-on-it-as-we-are-in-tp_serial_.patch
Patch10:            0010-fix-your-damn-email-address-nico.patch
Patch11:            0011-Install-unversioned-solibrary.patch
Patch12:            0012-Resolve-linking-against-ncursesw.patch
Patch13:            0013-Added-musl-support-to-libgpm-and-the-daemon.patch
Patch14:            0014-report-oops-constify-format-strings.patch
Patch15:            0015-report-avoid-Wformat-security-warnings.patch
Patch16:            0016-update-ignored-file-list.patch
Patch17:            0017-report-oops-add-attributes-to-mark-as-printf-functio.patch
Patch18:            0018-clean-up-a-few-unused-funcs-vars.patch
Patch19:            0019-fix-building-w-newer-glibc.patch
Patch20:            0020-dist-include-generated-autotools-in-tarballs.patch
Patch21:            0021-Add-gcc-include-path.patch
Patch22:            0022-fix-signedness-issue.patch
Patch23:            0023-Use-sigemptyset-API-instead-of-__sigemptyset.patch
Patch24:            0024-Update-gpm.c.patch
Patch25:            0025-Add-include-string.h.patch
Patch26:            0026-Update-liblow.c-for-musl-compatible.patch
Patch27:            0027-Aligned-comments.patch
Patch28:            0028-src-headers-daemon.h-avoid-redefinition-of-last_sele.patch

Requires(post):     info
Requires(preun):    info

BuildRequires:      sed gawk texinfo bison ncurses-devel libtool libcap-ng-devel
BuildRequires:      systemd-rpm-macros
BuildRequires:      gcc gcc-c++ make autoconf
Requires:           linuxconsoletools
Requires:           %{name}-libs = %{version}-%{release}

%description
The gpm (general purpose mouse) daemon tries to be a useful mouse
server for applications running on the Linux console. This package 
is intended as a replacement for "selection", to provide additional 
facilities.


%package libs
Summary:        Dynamic library for gpm

%description libs
This package contains the libgpm.so dynamic library which contains
the gpm system calls and library functions.

%package devel
Summary:        Development files for the gpm library
Requires:       %{name} = %{version}-%{release}
Requires:       %{name}-libs = %{version}-%{release}

%description devel
The gpm-devel package includes header files and libraries for developing 
programs which use the gpm library. The gpm provides mouse support to 
text-based Linux applications.

%package static
Summary: Static development files for the gpm library
Requires: %{name} = %{version}-%{release}

%description static
The gpm-static package includes static libraries of gpm. The gpm provides
mouse support to text-based Linux applications.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The gpm-doc package contains documentation files for gpm.


%prep
%autosetup -p1 -n %{name}-%{version}

%build
./autogen.sh
%configure
%{make_build}

%install
%{make_install}

chmod 0755 %{buildroot}/%{_libdir}/libgpm.so.%{LIBVER}
ln -sf libgpm.so.%{LIBVER} %{buildroot}/%{_libdir}/libgpm.so

rm -f %{buildroot}%{_datadir}/emacs/site-lisp/t-mouse.el

mkdir -p %{buildroot}%{_sysconfdir}/rc.d/init.d
mkdir -p %{buildroot}%{_unitdir}
install -m 0644 -p conf/gpm-* %{buildroot}%{_sysconfdir}

install -m 0644 -p %{SOURCE1} %{buildroot}%{_unitdir}
rm -rf %{buildroot}%{_initrddir}

%generate_compatibility_deps

%post
%systemd_post gpm.service

%preun
%systemd_preun gpm.service

%postun
%systemd_postun_with_restart gpm.service


%files
%config(noreplace) %{_sysconfdir}/gpm-*
%{_sbindir}/*
%{_bindir}/*
%{_infodir}/*
%{_unitdir}/gpm.service
%{_mandir}/man?/*
%{abidir}/*-option.list
%license COPYING

%files libs
%dir %{abidir}
%{_libdir}/libgpm.so.*
%{abidir}/libgpm.dump

%files devel
%{_libdir}/libgpm.so
%{_includedir}/*

%files static
%{_libdir}/libgpm.a

%files doc
%doc README doc/README* doc/Announce doc/FAQ doc/changelog TODO


%changelog
* Thu Apr 13 2023 chen_yu_ao <m15927509890@163.com> - 1.20.7-4
- change spec file format

* Thu Oct 27 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 1.20.7-3
- optimise spec file

* Fri Sep 30 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 1.20.7-2
- add doc package

* Fri Mar 25 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 1.20.7-1
- init from upstream
- sync pacthes from upstream
